#!/usr/bin/env python3

from pydantic import BaseModel
from unidecode import unidecode

class GeoLocation(BaseModel):
    latitude: float = .0
    longitude: float = .0
    description: str = ''

def str_to_hash(base: str):
    import hashlib
    return hashlib.md5(base.encode()).hexdigest()

def norm(string: str):
    return unidecode(string.casefold())



